#include "stdafx.h"
#include "ConfirmDialog.h"
#include "MarkDialog.h"

DUI_BEGIN_MESSAGE_MAP(CConfirmDialog, WindowImplBase)
DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, OnButtonClick)
DUI_END_MESSAGE_MAP()

CConfirmDialog* CConfirmDialog::sm_dialog = nullptr;

const bool CConfirmDialog::Popup(HWND parent, ConfirmType type)
{
	bool bCancel;
	sm_dialog = new CConfirmDialog(&bCancel, type);

	CMarkDialog::ShowMark(
		parent,
		nullptr);

	sm_dialog->Create(CMarkDialog::GetMarkHwnd(), _T("Popup"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_TOOLWINDOW,
		0,
		0,
		0,
		0);

	sm_dialog->CenterWindow();
	sm_dialog->ShowModal();
	CMarkDialog::DeleteMark();
	sm_dialog = nullptr;
	return bCancel;
}

VOID CConfirmDialog::InitWindow()
{
	m_UIBtnClose = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Close"));
	m_UIBtnDelete = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Delete"));
	m_UIBtnCancel = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Cancel"));
	m_UILayout = static_cast<CVerticalLayoutUI*>(m_pm.FindControl(L"Layout"));

	if (m_type == RemoveFingerprint)
		m_UILayout->SetBkImage(L"Images/Delete/img_bg.png");
	else if (m_type == RemoveQuickRun)
		m_UILayout->SetBkImage(L"Images/Delete/img_bg2.png");
}

VOID CConfirmDialog::OnButtonClick(TNotifyUI& msg)
{
	if (m_UIBtnClose == msg.pSender || m_UIBtnCancel == msg.pSender) {
		*m_bCancel = TRUE;
		Close();
	}
	else {
		*m_bCancel = FALSE;
		Close();
	}
}

LRESULT CConfirmDialog::HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
	if (uMsg == WM_DESTROY) {
		bHandled = TRUE;
		return 0;
	}
	return 0;
}

LRESULT CConfirmDialog::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
	// ʱյWM_NCDESTROYյwParamΪSC_CLOSEWM_SYSCOMMAND
	if (wParam == SC_CLOSE) {
		::PostQuitMessage(0L);
		bHandled = TRUE;
		return 0;
	}
	BOOL bZoomed = ::IsZoomed(*this);
	LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
	return lRes;
}