#pragma once
class CConfirmDialog :
	public WindowImplBase
{
public:
	typedef enum ConfirmType {
		RemoveFingerprint,
		RemoveQuickRun,
	};

	CVerticalLayoutUI* m_UILayout;
	CButtonUI* m_UIBtnClose, *m_UIBtnDelete, *m_UIBtnCancel;
	bool* m_bCancel;
	ConfirmType m_type;
	static CConfirmDialog* sm_dialog;
public:
	CConfirmDialog(bool* bCancel, ConfirmType type):
		m_UILayout(nullptr),
		m_UIBtnClose(nullptr),
		m_UIBtnCancel(nullptr),
		m_bCancel(nullptr) {
		m_bCancel = bCancel;
		m_type = type;
	}
	virtual ~CConfirmDialog() {}
	static const bool Popup(HWND parent, ConfirmType type);

	virtual void InitWindow();
	LRESULT HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	virtual CDuiString GetSkinFile() {
		return _T("Delete.xml");
	}

	virtual LPCTSTR GetWindowClassName() const {
		return _T("WhoAreYou_Popup");
	}

	virtual void OnFinalMessage(HWND hWnd) {
		__super::OnFinalMessage(hWnd);
		delete this;
	}

	virtual void Notify(TNotifyUI &msg) {
		return WindowImplBase::Notify(msg);
	}
	DUI_DECLARE_MESSAGE_MAP()
		virtual VOID OnButtonClick(TNotifyUI& msg);
};

