#include "stdafx.h"
#include "DeleteFinger.h"
#include "MarkDialog.h"
#include "..\Shared\ServiceSender.h"
#include "..\WAYBasics\Log.h"
#include "PopupDialog.h"

DUI_BEGIN_MESSAGE_MAP(CDeleteFinger, WindowImplBase)
DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, OnButtonClick)
DUI_END_MESSAGE_MAP()


CDeleteFinger* CDeleteFinger::sm_dialog = nullptr;

bool CDeleteFinger::Popup(HWND parent, int *result, CUIFinger* finger)
{
	int bSuccess = WAY_VERIFYDLG_NIL;
	sm_dialog = new CDeleteFinger(&bSuccess, result,finger);
	CMarkDialog::ShowMark(parent,nullptr);
	sm_dialog->Create(CMarkDialog::GetMarkHwnd(), _T("Popup"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_TOOLWINDOW, 0, 0, 0, 0);
	sm_dialog->CenterWindow();
	sm_dialog->ShowModal();
	CMarkDialog::DeleteMark();
	sm_dialog = nullptr;
	return bSuccess;

}
void CDeleteFinger::InitWindow()
{
	
	_LayoutAnimation = static_cast<CAnimationTabLayoutUI*>(m_pm.FindControl(L"AnimationFmaDeleteDialog"));
	_UIBtnClose = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Close"));
	_UIBtnDelete = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Delete"));
	_UIBtnCancel = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Cancel"));
	_LabelText = static_cast<CLabelUI*>(m_pm.FindControl(L"Label_WinFPDeleteAll_Text"));
	_LabelText1 = static_cast<CLabelUI*>(m_pm.FindControl(L"Label_WinFPDeleteAll_Text1"));
	_LabelText3 = static_cast<CLabelUI*>(m_pm.FindControl(L"Label_WinFPDeleteAll_Text3"));
	if (!_m_finger)
		_LabelText3->SetText(L"Delete all registered fingerprints?");
	_SpiritAnimation.Create(
		static_cast<CTextUI*>(m_pm.FindControl(L"img_Fma_DeleteFinger")),
		L"Images\\fpLogin\\",
		L"_3_",
		124);
	_SpiritAnimation.PlayAnimation(25);

}

void CDeleteFinger::OnButtonClick(TNotifyUI& msg)
{
	if (_UIBtnClose == msg.pSender)
	{
		*_m_result = WAY_VERIFYDLG_CLOSE;
		_SpiritAnimation.StopAnimation();
		Close();
	}
	else if (_UIBtnDelete == msg.pSender)
	{
		//ɾָ
		if (nullptr == _m_finger)
		{
			_LayoutAnimation->SelectItem(1);
			std::thread th([&] {
				if (S_OK != _DeleteAllWinbioFP())
				{
					//֤ʧ
					*_m_result = WAY_VERIFYDLG_NIL;
					_LabelText->SetText(L"Failed to verify!");
					_LabelText1->SetVisible(false);
					_SpiritAnimation.StopAnimation();
					std::this_thread::sleep_for(std::chrono::milliseconds(1000));
					Close();
				}
				else
				{
					//֤ɹ
					*_m_result = WAY_VERIFYDLG_OK;
					_SpiritAnimation.StopAnimation();
					_LabelText->SetText(L"Successed to Verify!");
					_LabelText1->SetVisible(false);
					std::this_thread::sleep_for(std::chrono::milliseconds(1000));
					Close();
				}
			});
			th.detach();
		}
		//ɾһöָ
		else 
		{
			_LayoutAnimation->SelectItem(1);
			std::thread th([&] {
				if (S_OK != _DeleteWinbioFP(_m_finger))
				{
					//֤ʧ
					*_m_result = WAY_VERIFYDLG_NIL;
					_LabelText->SetText(L"Failed to verify!");
					_LabelText1->SetVisible(false);
					_SpiritAnimation.StopAnimation();
					std::this_thread::sleep_for(std::chrono::milliseconds(1000));
					Close();
				}
				else
				{
					//֤ɹ
					*_m_result = WAY_VERIFYDLG_OK;
					_SpiritAnimation.StopAnimation();
					_LabelText->SetText(L"Successed to Verify!");
					_LabelText1->SetVisible(false);
					std::this_thread::sleep_for(std::chrono::milliseconds(1000));
					Close();
				}
			});
			th.detach();
		}
	}
	else if (_UIBtnCancel == msg.pSender)
	{
		*_m_result = WAY_VERIFYDLG_CLOSE;
		_SpiritAnimation.StopAnimation();
		Close();
	}
}

HRESULT CDeleteFinger::_DeleteWinbioFP(CUIFinger* finger)
{
	HRESULT hr = S_OK;
	WINBIO_IDENTITY identity = { 0 };
	WINBIO_SESSION_HANDLE sessionHandle = NULL;
	WINBIO_UNIT_ID unitId = 0;
	PWINBIO_UNIT_SCHEMA unitSchema = NULL;
	SIZE_T unitCount = 0;
	WINBIO_BIOMETRIC_SUBTYPE subFactor = 0;
	WINBIO_REJECT_DETAIL rejectDetail = 0;

	hr = WinBioOpenSession(
		WINBIO_TYPE_FINGERPRINT,    // Service provider
		WINBIO_POOL_SYSTEM,         // Pool type
		WINBIO_FLAG_DEFAULT,        // Configuration and access
		NULL,                       // Array of biometric unit IDs
		0,                          // Count of biometric unit IDs
		NULL,						// Database ID
		&sessionHandle              // [out] Session handle
	);
	if (FAILED(hr))
	{
		goto e_Exit;
	}
	hr = WinBioIdentify(
		sessionHandle,              // Session handle
		&unitId,                    // Biometric unit ID
		&identity,                  // User SID
		&subFactor,                 // Finger sub factor
		&rejectDetail               // Rejection information
	);

	if (FAILED(hr))
	{
		goto e_Exit;
	}


	if (FAILED(hr = WinBioDeleteTemplate(
		sessionHandle,
		unitId,
		&identity,
		finger->m_Type)))
	{
		goto e_Exit;
	}

	if (sessionHandle != NULL)
	{
		WinBioCloseSession(sessionHandle);
		sessionHandle = NULL;
	}
	return S_OK;

e_Exit:
	if (sessionHandle != NULL)
	{
		WinBioCloseSession(sessionHandle);
		sessionHandle = NULL;
	}
	return S_FALSE;
}

HRESULT  CDeleteFinger::_DeleteAllWinbioFP()
{
	HRESULT hr = S_OK;
	WINBIO_IDENTITY identity = { 0 };
	WINBIO_SESSION_HANDLE sessionHandle = NULL;
	WINBIO_UNIT_ID unitId = 0;
	PWINBIO_UNIT_SCHEMA unitSchema = NULL;
	SIZE_T unitCount = 0;
	WINBIO_BIOMETRIC_SUBTYPE subFactor = 0;
	WINBIO_REJECT_DETAIL rejectDetail = 0;

	hr = WinBioOpenSession(
		WINBIO_TYPE_FINGERPRINT,    // Service provider
		WINBIO_POOL_SYSTEM,         // Pool type
		WINBIO_FLAG_DEFAULT,        // Configuration and access
		NULL,                       // Array of biometric unit IDs
		0,                          // Count of biometric unit IDs
		NULL,						// Database ID
		&sessionHandle              // [out] Session handle
	);
	if (FAILED(hr))
	{
		goto e_Exit;
	}
	hr = WinBioIdentify(
		sessionHandle,              // Session handle
		&unitId,                    // Biometric unit ID
		&identity,                  // User SID
		&subFactor,                 // Finger sub factor
		&rejectDetail               // Rejection information
	);

	if (FAILED(hr))
	{
		goto e_Exit;
	}


	if (FAILED(hr = WinBioDeleteTemplate(
		sessionHandle,
		unitId,
		&identity,
		WINBIO_SUBTYPE_ANY)))
	{
		goto e_Exit;
	}

	if (sessionHandle != NULL)
	{
		WinBioCloseSession(sessionHandle);
		sessionHandle = NULL;
	}
	return S_OK;

e_Exit:
	if (sessionHandle != NULL)
	{
		WinBioCloseSession(sessionHandle);
		sessionHandle = NULL;
	}
	return S_FALSE;
}

HRESULT CDeleteFinger::GetCurrentUserIdentity(__inout PWINBIO_IDENTITY Identity)
{
	// Declare variables.
	HRESULT hr = S_OK;
	HANDLE tokenHandle = NULL;
	DWORD bytesReturned = 0;
	struct {
		TOKEN_USER tokenUser;
		BYTE buffer[SECURITY_MAX_SID_SIZE];
	} tokenInfoBuffer;

	// Zero the input identity and specify the type.
	ZeroMemory(Identity, sizeof(WINBIO_IDENTITY));
	Identity->Type = WINBIO_ID_TYPE_NULL;

	// Open the access token associated with the
	// current process
	if (!OpenProcessToken(
		GetCurrentProcess(),            // Process handle
		TOKEN_READ,                     // Read access only
		&tokenHandle))                  // Access token handle
	{
		DWORD win32Status = GetLastError();
		wprintf_s(L"Cannot open token handle: %d\n", win32Status);
		hr = HRESULT_FROM_WIN32(win32Status);
		goto e_Exit;
	}

	// Zero the tokenInfoBuffer structure.
	ZeroMemory(&tokenInfoBuffer, sizeof(tokenInfoBuffer));

	// Retrieve information about the access token. In this case,
	// retrieve a SID.
	if (!GetTokenInformation(
		tokenHandle,                    // Access token handle
		TokenUser,                      // User for the token
		&tokenInfoBuffer.tokenUser,     // Buffer to fill
		sizeof(tokenInfoBuffer),        // Size of the buffer
		&bytesReturned))                // Size needed
	{
		DWORD win32Status = GetLastError();
		wprintf_s(L"Cannot query token information: %d\n", win32Status);
		hr = HRESULT_FROM_WIN32(win32Status);
		goto e_Exit;
	}

	// Copy the SID from the tokenInfoBuffer structure to the
	// WINBIO_IDENTITY structure. 
	CopySid(
		SECURITY_MAX_SID_SIZE,
		Identity->Value.AccountSid.Data,
		tokenInfoBuffer.tokenUser.User.Sid
	);

	// Specify the size of the SID and assign WINBIO_ID_TYPE_SID
	// to the type member of the WINBIO_IDENTITY structure.
	Identity->Value.AccountSid.Size = GetLengthSid(tokenInfoBuffer.tokenUser.User.Sid);
	Identity->Type = WINBIO_ID_TYPE_SID;

e_Exit:
	if (tokenHandle != NULL)
	{
		CloseHandle(tokenHandle);
	}
	return hr;
}

LRESULT CDeleteFinger::HandleCustomMessage(
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam,
	BOOL& bHandled)
{
	LRESULT lRes = 0;
	switch (uMsg)
	{
	case STATE_SYSTEM_SELECTED:break;
	default: break;
	}
	return lRes;
}

LRESULT CDeleteFinger::OnSysCommand(
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam,
	BOOL& bHandled)
{
	// ʱյWM_NCDESTROYյwParamΪSC_CLOSEWM_SYSCOMMAND
	if (wParam == SC_CLOSE)
	{
		::PostQuitMessage(0L);
		bHandled = true;
		return 0;
	}
	BOOL bZoomed = ::IsZoomed(*this);
	LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
	return lRes;
}

