#pragma once
#include "..\Shared\SpiritUI.h"
#include "UIFinger.h"

class CDeleteFinger :
	public WindowImplBase
{

protected:
	CSpiritUI _SpiritAnimation;
	CTabLayoutUI *_LayoutAnimation = nullptr;
	CButtonUI
		*_UIBtnClose = nullptr,
		*_UIBtnDelete = nullptr,
		*_UIBtnCancel = nullptr;

	CLabelUI *_LabelText = nullptr,
		*_LabelText1 = nullptr,
		*_LabelText3 = nullptr;

	int *_m_result = nullptr;
	int *_bSuccess = nullptr;
	CUIFinger* _m_finger = nullptr;
	static CDeleteFinger* sm_dialog;

public:
	CDeleteFinger(int* bSuccess, int *result, CUIFinger* finger)
	{
		_bSuccess = bSuccess;
		_m_result = result;
		_m_finger = finger;
	};
	virtual ~CDeleteFinger()
	{
		_m_result = nullptr;
	};

	HRESULT _DeleteAllWinbioFP();
	HRESULT _DeleteWinbioFP(CUIFinger* finger);
	HRESULT GetCurrentUserIdentity(
		__inout PWINBIO_IDENTITY Identity);
	static bool Popup(HWND parent, int *result, CUIFinger* finger);

	LRESULT HandleCustomMessage(
		UINT uMsg,
		WPARAM wParam,
		LPARAM lParam,
		BOOL& bHandled);

	LRESULT OnSysCommand(
		UINT uMsg,
		WPARAM wParam,
		LPARAM lParam,
		BOOL& bHandled);

	virtual void InitWindow();

	virtual CDuiString GetSkinFile()
	{
		return _T("DeleteFinger.xml");
	}

	virtual LPCTSTR GetWindowClassName() const
	{
		return _T("FMA-DeleteFinger");
	}

	virtual void OnFinalMessage(HWND hWnd)
	{
		__super::OnFinalMessage(hWnd);
		delete this;
	}

	virtual void Notify(TNotifyUI &msg)
	{
		return WindowImplBase::Notify(msg);
	}

	DUI_DECLARE_MESSAGE_MAP()
		virtual VOID OnButtonClick(TNotifyUI& msg);




};

