#include "stdafx.h"
#include "FMAMainDialog.h"
#include "PopupDialog.h"
#include "ConfirmDialog.h"
#include "..\WAYBasics\Log.h"
#include "..\WAYBasics\DBQuerys.h"
#include "..\WhoAreYouClient\WAYErrorDefine.h"
#include "DeleteFinger.h"
#include "WindowsPwdDialog.h"

DUI_BEGIN_MESSAGE_MAP(CFMAMainDialog, WindowImplBase)
DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, OnButtonClick)
DUI_ON_MSGTYPE(DUI_MSGTYPE_MOUSEENTER, OnMouseEnter)
DUI_ON_MSGTYPE(DUI_MSGTYPE_MOUSELEAVE , OnMouseLeave)
DUI_ON_MSGTYPE(DUI_MSGTYPE_SELECTCHANGED, OnOptionChange)
DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnWindowInit)
DUI_END_MESSAGE_MAP()

using namespace WAY;

VOID CALLBACK CaptureSampleCallback(
	__in_opt PVOID CaptureCallbackContext,
	__in HRESULT OperationStatus,
	__in WINBIO_UNIT_ID UnitId,
	__in_bcount(SampleSize) PWINBIO_BIR Sample,
	__in SIZE_T SampleSize,
	__in WINBIO_REJECT_DETAIL RejectDetail
);

//ص
VOID CALLBACK CaptureSampleCallback(
	__in_opt PVOID CaptureCallbackContext,
	__in HRESULT OperationStatus,
	__in WINBIO_UNIT_ID UnitId,
	__in_bcount(SampleSize) PWINBIO_BIR Sample,
	__in SIZE_T SampleSize,
	__in WINBIO_REJECT_DETAIL RejectDetail
)
{
	UNREFERENCED_PARAMETER(CaptureCallbackContext);

	E("[CaptureSampleCallback]:CaptureSampleCallback executing.\n");
	E("[CaptureSampleCallback]:Swipe processed - Unit ID: %d\n", UnitId);

	if (FAILED(OperationStatus))
	{
		if (OperationStatus == WINBIO_E_BAD_CAPTURE)
		{
			E("[CaptureSampleCallback]: Bad capture; reason: %d\n", RejectDetail);
		}
		else
		{
			E("[CaptureSampleCallback]:WinBioCaptureSampleWithCallback failed.\n");
			E("[CaptureSampleCallback]:OperationStatus = 0x%x\n", OperationStatus);
		}
		goto e_Exit;
	}

	E("[CaptureSampleCallback]: Captured %d bytes.\n", SampleSize);

e_Exit:

	if (Sample != NULL)
	{
		WinBioFree(Sample);
		Sample = NULL;
	}
}

void CFMAMainDialog::InitWindow()
{
	//ɾϵͳеָƽΪʹ
	//_DeleteAllWinbioFP();
	if (!_Init()) 
	{
		::MessageBoxA(NULL,
			"FMA init failed.",
			"Runtime error",
			MB_ICONERROR | MB_OK);
		PostQuitMessage(0l);
	}
	CUIFinger::InitFingers(&m_pm, _Fingers);
	_UIAnimationLayout = static_cast<CAnimationTabLayoutUI*>(m_pm.FindControl(L"AnimationLayout"));
	_UIRegistProgressImg = static_cast<CTextUI*>(m_pm.FindControl(L"img_fingerprint_state"));
	_UIRegistProgress = static_cast<CProgressUI*>(m_pm.FindControl(L"progress_fingerprint"));
	_UIRegistTip = static_cast<CLabelUI*>(m_pm.FindControl(L"label_regist_text"));
	_UIBtnOK = static_cast<CButtonUI*>(m_pm.FindControl(L"btn_ok"));
	_UIBtnClose = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Close"));
	_UIBtnMini = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Mini"));
	_UIBtnCancelRegist = static_cast<CButtonUI*>(m_pm.FindControl(L"btn_fma_cancelRegist"));
	_UIBtnDeleteAll = static_cast<CButtonUI*>(m_pm.FindControl(L"btn_fma_deleteall"));
}
//ʼLOGDBͻȡϵͳû10öָʼָδעָƣ0-δע᣻1-עᣩ
const bool CFMAMainDialog::_Init()
{
	std::string dbPath = Common::GetCurrentPath();
	DWORD cb = 128;
	CHAR username[128] = { 0 };
	int res = 0;

	dbPath += "Data\\DB\\WAY.db";
	Log::Instance()->Init("Data\\Log\\");

	if ((res = DBQuerys::Instance()->InitDB(dbPath))) 
	{
		E("FMA: Database init failed, error=%d.\n", res);
		return false;
	}
	::GetUserNameA(username, &cb);//ȡϵͳûusername
	_CurrentUser = username;
	F("FMA: Current system user: %s.\n", username);
	if (WAY_E_DB_NO_DATA == DBQuerys::Instance()->FMA_QueryFingersByUsername(
		username,
		_UserRecords)) 
	{
		F("FMA: Create DB record for '%s' user.\n", username);
		DBQuerys::Instance()->FMA_InsertUser(username);
	}
	else
	{
		F("FMA: '%s' user already exist in DB.\n", username);
	}
	return true;
}

//Ҫ_UserRecordsĳʼ
//нʾĳʼעָͼ
void CFMAMainDialog::OnWindowInit(
	TNotifyUI& msg)
{
	if (!_UserRecords.size())
		return;
	for (int n = 0; n < _UserRecords.size(); n++) {
		if (!_UserRecords[n])
			continue;
		_Fingers[n].Regist(true);
	}
}

void CFMAMainDialog::OnButtonClick(
	TNotifyUI& msg)
{
	//עɹȷťϢ
	if (msg.pSender == _UIBtnOK) 
	{
		_CurrentFinger->Regist(true);
		_UIAnimationLayout->SelectItem(0);
		//עɹݿ
		DBQuerys::Instance()->FMA_UpdateFinger(
			_CurrentUser.c_str(),
			_CurrentFinger->m_Type,
			true);

		_CurrentFinger = nullptr;
		return;
	}
	else if (msg.pSender == _UIBtnClose) 
	{
		F("FMA: Closing from close button.\n");
		Close(0l);
		return;
	}
	else if (msg.pSender == _UIBtnMini) {
		F("FMA: Size from mini size button.\n");
		SendMessage(WM_SYSCOMMAND, SC_MINIMIZE, 0);
		return;
	}
	else if (msg.pSender == _UIBtnCancelRegist) {
		F("FMA: cancel resisting.\n");
		closeSession();
		return;
	}
	else if (msg.pSender == _UIBtnDeleteAll) {
		int fingers = 0;
		DBQuerys::Instance()->FMA_QueryRegistedFingersByUsername(
			_CurrentUser,
			fingers);
		if (!fingers)
		{
			CPopupDialog::Popup(
				m_hWnd,
				CPopupDialog::PopType::Warning,
				L"No fingerprint, please register first",
				false);
			return;
		}
		F("FMA: delete all fps.\n");
		int returnVal;
		CDeleteFinger::Popup(m_hWnd, &returnVal, nullptr);
		switch (returnVal)
		{
		case WAY_VERIFYDLG_NIL:break;
		case WAY_VERIFYDLG_CLOSE:break;
		case WAY_VERIFYDLG_OK:
			UpdateUI(nullptr);
			break;
		default:
			break;
		return;
		}
	}
}

void CFMAMainDialog::OnMouseEnter(
	TNotifyUI& msg)
{
	_FindFinger([&](CUIFinger& item)->const bool 
	{
		return item.IsEnter(msg) ? false : true;
	});
}

void CFMAMainDialog::OnMouseLeave(
	TNotifyUI& msg)
{
	_FindFinger([&](CUIFinger& item)->const bool 
	{
		return item.IsLeave(msg) ? false : true;
	});
}

void CFMAMainDialog::OnOptionChange(
	TNotifyUI& msg)
{
	if (!((COptionUI*)msg.pSender)->IsSelected())
		return;
	CUIFinger* finger;
	_FindFinger([&](CUIFinger& item)->const bool 
	{
		if (msg.pSender == item.m_UIOption) {
			finger = &item;
			return false;
		}
		return true;
	});
	FW(L"FMA: '%s' option selected.\n", finger->m_UIOption->GetName().GetData());
	CDuiString fingerName = finger->m_UIOption->GetName().GetData();
	if (!finger->m_bRegisted) {
		_CurrentFinger = finger;
		int isFirst;
		F("[DBQuerys]:QueryFMAIsFirst");
		DBQuerys::Instance()->QueryFMAIsFirst(_CurrentUser, isFirst);
		F("[DBQuerys]:QueryFMAIsFirst1");
		if (!isFirst) 
		{
			//һעᣬҪwindows½֤
			if (!CWindowsPwdDialog::Popup(m_hWnd))
			{
				DBQuerys::Instance()->UpdateFMAIsFirst(_CurrentUser, 1);
				std::thread th([&] {
					_RegistWinbioFP(finger);
				});
				th.detach();
			}

		}
		else 
		{
			std::thread th([&] {
				_RegistWinbioFP(finger);
			});
			th.detach();
		}
		
		
	}
	else
	{
		//_DeleteWinbioFP(finger);
		F("FMA: delete one finger.\n");
		int returnVal;
		CDeleteFinger::Popup(m_hWnd, &returnVal, finger);
		switch (returnVal)
		{
		case WAY_VERIFYDLG_NIL:break;
		case WAY_VERIFYDLG_CLOSE:break;
		case WAY_VERIFYDLG_OK:
			UpdateUI(finger);
			break;
		default:
			break;
			return;
		}
	}
}


void CFMAMainDialog::UpdateUI(CUIFinger* finger)
{
	//һöָɾ޸ĽʾԼݿı仯
	if (finger)
	{
		DBQuerys::Instance()->FMA_UpdateFinger(
			_CurrentUser.c_str(),
			finger->m_Type,
			false);
		finger->Regist(false);
		F("FMA: Delete regist fingerprint successed.\n");
	}
	//ָɾ޸ĽʾԼݿı仯
	else 
	{
		for (int n = 0; n < _Fingers.size(); n++)
		{
			_Fingers[n].Regist(false);
		}
		DBQuerys::Instance()->FMA_UpdateFingerAfterDeleteAll(_CurrentUser.c_str());
	}
}

void CFMAMainDialog::_FindFinger(
	std::function<const bool(CUIFinger&)> cb)
{
	for (auto& itor : _Fingers) 
	{
		if (!cb(itor))
			break;
	}
}

void CFMAMainDialog::_RegistWinbioFP(
	CUIFinger* finger)
{
	HRESULT hr = S_OK;
	WINBIO_IDENTITY identity{ 0 };
	WINBIO_UNIT_ID unitID = 0;
	WINBIO_REJECT_DETAIL rejectDetail = 0;
	BOOL isNewTemplate = TRUE;
	PWINBIO_UNIT_SCHEMA unitSchema = NULL;
	SIZE_T unitCount = 0;

	_UIAnimationLayout->SelectItem(1);
	F("FMA: AnimationLayout select: 1.\n");
	F("FMA: Begin regist fingerprint.\n");

	if (FAILED(hr = WinBioOpenSession(
		WINBIO_TYPE_FINGERPRINT,
		WINBIO_POOL_SYSTEM,
		WINBIO_FLAG_DEFAULT,
		NULL,
		0,
		NULL,
		&_m_sessionHandle)))
	{
		hr = WINBIO_E_SENSOR_UNAVAILABLE;
		E("FMA: func:'WinBioOpenSession' failed, res:'%x'.\n", hr);
		goto _END;
	}
	//豸ʱʱػᴮ
	if (FAILED(hr = WinBioEnumBiometricUnits(
		WINBIO_TYPE_FINGERPRINT,
		&unitSchema,
		&unitCount)))
	{
		E("FMA: func:'WinBioEnumBiometricUnits' failed, res:'%x'.\n", hr);
		goto _END;
	}
	unitID = unitSchema[0].UnitId;
	hr = WinBioLocateSensor(_m_sessionHandle, &unitID);
	if (FAILED(hr))
	{
		wprintf_s(L"\n WinBioLocateSensor failed. hr = 0x%x\n", hr);
		goto _END;
	}

	if (FAILED(hr = WinBioEnrollBegin(
		_m_sessionHandle,
		finger->m_Type,
		unitID)))
	{
		E("FMA: func:'WinBioEnrollBegin' failed, res:'%x'.\n", hr);
		goto _END;
	}

	for (int captureTimes = 1;; captureTimes++)
	{
		F("FMA: Registing [%d] times fingerprint...\n",
			captureTimes);
		Sleep(300);
		hr = WinBioEnrollCapture(
			_m_sessionHandle,
			&rejectDetail);

		if (hr == WINBIO_I_MORE_DATA)
		{
			F("FMA: Registing need more captures....\n");
			TCHAR number[16] = { 0 }, number2[16] = { 0 };
			std::wstring imgPath = L"Images\\img_regist_",
				tip = L"Please raise your finger and change angle,entry ";
			_itow(captureTimes, number, 10);
			_itow(captureTimes + 1, number2, 10);
			imgPath += number2; imgPath += L".png";
			tip += number; tip += L" times... ";
			_UIRegistProgressImg->SetBkImage(imgPath.c_str());
			_UIRegistProgress->SetValue(_UIRegistProgress->GetValue() + 7);
			_UIRegistTip->SetText(tip.c_str());
			continue;
		}
		if (FAILED(hr)) {
			E("FMA: func:'WinBioEnrollCapture' failed, res:'%x', rejectDetail:'%d', on '%d' times.\n",
				hr,
				rejectDetail,
				captureTimes);
			goto _END;
		}
		else {
			BOOLEAN temp = true;
			F("FMA: Fingerprint regist successed.\n");
			if (FAILED(hr = WinBioEnrollCommit(
				_m_sessionHandle,
				&identity,
				&temp)))
			{
				E("FMA: func:'WinBioEnrollCommit' failed, res:'%x'.\n", hr);
				goto _END;
			}
			F("FMA: AnimationLayout select: 2.\n");
			_UIAnimationLayout->SelectItem(2);
			break;
		}
	}
_END:
	if (FAILED(hr))
		SendMessage(WM_REGIST_FAILED);

	if (_m_sessionHandle != NULL)
	{
		WinBioCloseSession(_m_sessionHandle);
		_m_sessionHandle = NULL;
	}
	_ResetRegistUI();
}

void CFMAMainDialog::_DeleteAllWinbioFP() 
{
	HRESULT hr = S_OK;
	WINBIO_IDENTITY identity = { 0 };
	WINBIO_SESSION_HANDLE sessionHandle = NULL;
	WINBIO_UNIT_ID unitId = 0;
	PWINBIO_UNIT_SCHEMA unitSchema = NULL;
	SIZE_T unitCount = 0;
	if (FAILED(hr = GetCurrentUserIdentity(&identity)))
	{
		E("FMA: func:'GetCurrentUserIdentity' failed, res:'%x'.\n", hr);
	}
	if (FAILED(hr = WinBioOpenSession(
		WINBIO_TYPE_FINGERPRINT,    // Service provider
		WINBIO_POOL_SYSTEM,         // Pool type
		WINBIO_FLAG_DEFAULT,        // Configuration and access
		NULL,                       // Array of biometric unit IDs
		0,                          // Count of biometric unit IDs
		NULL,                       // Database ID
		&sessionHandle              // [out] Session handle
	))) {
		E("FMA: func:'WinBioOpenSession' failed, res:'%x'.\n", hr);
	}
	if (FAILED(hr = WinBioEnumBiometricUnits(
		WINBIO_TYPE_FINGERPRINT,        // Type of biometric unit
		&unitSchema,                    // Array of unit schemas
		&unitCount)))                  // Count of unit schemas
	{
		E("FMA: func:'WinBioEnumBiometricUnits' failed, res:'%x'.\n", hr);
	}
	unitId = unitSchema[0].UnitId;
	if (FAILED(hr = WinBioDeleteTemplate(
		sessionHandle,
		unitId,
		&identity,
		WINBIO_SUBTYPE_ANY)))
	{
		E("FMA: func:'WinBioDeleteTemplate' failed, res:'%x'.\n", hr);
	}
	if (sessionHandle != NULL)
	{
		WinBioCloseSession(sessionHandle);
		sessionHandle = NULL;
	}
	if (unitSchema != NULL)
	{
		WinBioFree(unitSchema);
		unitSchema = NULL;
	}
}

void CFMAMainDialog::_DeleteWinbioFP(
	CUIFinger* finger) 
{
	F("FMA: Delete regist fingerprint.\n");
	bool bCancel = CConfirmDialog::Popup(
		m_hWnd,
		CConfirmDialog::ConfirmType::RemoveFingerprint);
	if (bCancel) {
		finger->m_UIOption->Selected(false);
		return;
	}

	HRESULT hr = S_OK;
	WINBIO_IDENTITY identity = { 0 };
	WINBIO_SESSION_HANDLE sessionHandle = NULL;
	WINBIO_UNIT_ID unitId = 0;
	PWINBIO_UNIT_SCHEMA unitSchema = NULL;
	SIZE_T unitCount = 0;

	if (FAILED(hr = GetCurrentUserIdentity(&identity)))
	{
		E("FMA: func:'GetCurrentUserIdentity' failed, res:'%x'.\n", hr);
		goto e_Exit;
	}
	if (FAILED(hr = WinBioOpenSession(
		WINBIO_TYPE_FINGERPRINT,    // Service provider
		WINBIO_POOL_SYSTEM,         // Pool type
		WINBIO_FLAG_DEFAULT,        // Configuration and access
		NULL,                       // Array of biometric unit IDs
		0,                          // Count of biometric unit IDs
		NULL,                       // Database ID
		&sessionHandle              // [out] Session handle
	))) {
		E("FMA: func:'WinBioOpenSession' failed, res:'%x'.\n", hr);
		goto e_Exit;
	}
	if (FAILED(hr = WinBioEnumBiometricUnits(
		WINBIO_TYPE_FINGERPRINT,        // Type of biometric unit
		&unitSchema,                    // Array of unit schemas
		&unitCount)))                  // Count of unit schemas
	{
		E("FMA: func:'WinBioEnumBiometricUnits' failed, res:'%x'.\n", hr);
		goto e_Exit;
	}
	unitId = unitSchema[1].UnitId;
	if (FAILED(hr = WinBioDeleteTemplate(
		sessionHandle,
		unitId,
		&identity,
		finger->m_Type)))
	{
		E("FMA: func:'WinBioDeleteTemplate' failed, res:'%x'.\n", hr);
		goto e_Exit;
	}

e_Exit:
	if (FAILED(hr)) {
		CPopupDialog::Popup(
			m_hWnd,
			CPopupDialog::PopType::Warning,
			L"Fingerprint deletion failed, please try again",
			false);
	}
	else {
		DBQuerys::Instance()->FMA_UpdateFinger(
			_CurrentUser.c_str(),
			finger->m_Type,
			false);
		finger->Regist(false);
		F("FMA: Delete regist fingerprint successed.\n");
	}

	if (sessionHandle != NULL)
	{
		WinBioCloseSession(sessionHandle);
		sessionHandle = NULL;
	}
	if (unitSchema != NULL)
	{
		WinBioFree(unitSchema);
		unitSchema = NULL;
	}
}


HRESULT CFMAMainDialog::closeSession()
{
	HRESULT hr = S_OK;
	if (_m_sessionHandle)
	{
		hr = WinBioCaptureSampleWithCallback(
			_m_sessionHandle,                  // Open session handle
			WINBIO_NO_PURPOSE_AVAILABLE,    // Intended use of the sample
			WINBIO_DATA_FLAG_RAW,           // Sample format
			CaptureSampleCallback,          // Callback function
			NULL                            // Optional context
		);
		if (FAILED(hr))
		{
			E("\n WinBioCaptureSampleWithCallback failed. ");
			E("hr = 0x%x\n", hr);
			goto e_Exit;
		}

		hr = WinBioCancel(_m_sessionHandle);
		if (FAILED(hr))
		{
			E("\n WinBioCancel failed. hr = 0x%x\n", hr);
			goto e_Exit;
		}
		hr = WinBioWait(_m_sessionHandle);
		if (FAILED(hr))
		{
			E("\n WinBioWait failed. hr = 0x%x\n", hr);
		}

	e_Exit:

		if (_m_sessionHandle != NULL)
		{
			WinBioCloseSession(_m_sessionHandle);
			_m_sessionHandle = NULL;
		}
		return hr;
	}
}


HRESULT CFMAMainDialog::GetCurrentUserIdentity(__inout PWINBIO_IDENTITY Identity)
{
	// Declare variables.
	HRESULT hr = S_OK;
	HANDLE tokenHandle = NULL;
	DWORD bytesReturned = 0;
	struct {
		TOKEN_USER tokenUser;
		BYTE buffer[SECURITY_MAX_SID_SIZE];
	} tokenInfoBuffer;

	// Zero the input identity and specify the type.
	ZeroMemory(Identity, sizeof(WINBIO_IDENTITY));
	Identity->Type = WINBIO_ID_TYPE_NULL;

	// Open the access token associated with the
	// current process
	if (!OpenProcessToken(
		GetCurrentProcess(),            // Process handle
		TOKEN_READ,                     // Read access only
		&tokenHandle))                  // Access token handle
	{
		DWORD win32Status = GetLastError();
		wprintf_s(L"Cannot open token handle: %d\n", win32Status);
		hr = HRESULT_FROM_WIN32(win32Status);
		goto e_Exit;
	}

	// Zero the tokenInfoBuffer structure.
	ZeroMemory(&tokenInfoBuffer, sizeof(tokenInfoBuffer));

	// Retrieve information about the access token. In this case,
	// retrieve a SID.
	if (!GetTokenInformation(
		tokenHandle,                    // Access token handle
		TokenUser,                      // User for the token
		&tokenInfoBuffer.tokenUser,     // Buffer to fill
		sizeof(tokenInfoBuffer),        // Size of the buffer
		&bytesReturned))                // Size needed
	{
		DWORD win32Status = GetLastError();
		wprintf_s(L"Cannot query token information: %d\n", win32Status);
		hr = HRESULT_FROM_WIN32(win32Status);
		goto e_Exit;
	}

	// Copy the SID from the tokenInfoBuffer structure to the
	// WINBIO_IDENTITY structure. 
	CopySid(
		SECURITY_MAX_SID_SIZE,
		Identity->Value.AccountSid.Data,
		tokenInfoBuffer.tokenUser.User.Sid
	);

	// Specify the size of the SID and assign WINBIO_ID_TYPE_SID
	// to the type member of the WINBIO_IDENTITY structure.
	Identity->Value.AccountSid.Size = GetLengthSid(tokenInfoBuffer.tokenUser.User.Sid);
	Identity->Type = WINBIO_ID_TYPE_SID;

e_Exit:
	if (tokenHandle != NULL)
	{
		CloseHandle(tokenHandle);
	}
	return hr;
}

void CFMAMainDialog::_ResetRegistUI()
{
	_UIRegistProgress->SetValue(0);
	_UIRegistTip->SetText(L"Please press the fingerprint sensor...");
	_UIRegistProgressImg->SetBkImage(L"Images\\img_regist_0.png");
}

LRESULT CFMAMainDialog::HandleCustomMessage(
	UINT uMsg, 
	WPARAM wParam, 
	LPARAM lParam, 
	BOOL& bHandled) {
	if (uMsg == WM_DESTROY) 
	{
		bHandled = TRUE;
		::PostQuitMessage(0L);
	}
	else if (uMsg == WM_REGIST_FAILED) 
	{
		bHandled = TRUE;
		/*CPopupDialog::Popup(
			m_hWnd,
			CPopupDialog::PopType::Warning,
			L"ָ¼ʧܣ!",
			false);*/
		F("FMA: AnimationLayout select: 0.\n");
		_UIAnimationLayout->SelectItem(0);
		_CurrentFinger->m_UIOption->Selected(false);
		_CurrentFinger = nullptr;
	}
	return 0;
}

LRESULT CFMAMainDialog::OnSysCommand(
	UINT uMsg, 
	WPARAM wParam, 
	LPARAM lParam, 
	BOOL& bHandled) {
	// ʱյWM_NCDESTROYյwParamΪSC_CLOSEWM_SYSCOMMAND
	if (wParam == SC_CLOSE) {
		::PostQuitMessage(0L);
		bHandled = TRUE;
		return 0;
	}
	BOOL bZoomed = ::IsZoomed(*this);
	LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
	return lRes;
}