#pragma once
#include "UIFinger.h"

#define WM_REGIST_FAILED WM_USER + 10000

class CFMAMainDialog :
	public WindowImplBase
{

public:
	typedef enum DeleteType {
		OneFingerprint,
		AllFingerprints,
	};
	DeleteType _m_type;

protected:
	std::string _CurrentUser = "";

	std::vector<CUIFinger> _Fingers;
	//¼ûӦָǷѾйָעᡣ
	//ע - 1(true)δע - 0(false) boolֵΪ˽гʼʹ
	std::vector<bool> _UserRecords;
	WINBIO_SESSION_HANDLE _m_sessionHandle = NULL;
	CAnimationTabLayoutUI* _UIAnimationLayout = nullptr;
	CTextUI* _UIRegistProgressImg = nullptr;
	CLabelUI* _UIRegistTip = nullptr;
	CProgressUI* _UIRegistProgress = nullptr;
	CButtonUI* _UIBtnOK = nullptr,
		*_UIBtnClose = nullptr,
		*_UIBtnMini = nullptr,
		*_UIBtnCancelRegist = nullptr,
		*_UIBtnDeleteAll = nullptr;

	CUIFinger* _CurrentFinger = nullptr;
public:
	CFMAMainDialog() {}
	virtual ~CFMAMainDialog() {}

	virtual void InitWindow();

	LRESULT HandleCustomMessage(
		UINT uMsg, 
		WPARAM wParam, 
		LPARAM lParam, 
		BOOL& bHandled);

	LRESULT OnSysCommand(
		UINT uMsg, 
		WPARAM wParam, 
		LPARAM lParam, 
		BOOL& bHandled);

	virtual CDuiString GetSkinFile() 
	{
		return _T("FMA.xml");
	}

	virtual LPCTSTR GetWindowClassName() const 
	{
		return _T("WhoAreYou_FMA");
	}

	virtual void OnFinalMessage(
		HWND hWnd) 
	{
		__super::OnFinalMessage(hWnd);
		delete this;
	}

	virtual void Notify(
		TNotifyUI &msg) 
	{
		return WindowImplBase::Notify(msg);
	}

protected:
	const bool _Init();
	void _FindFinger(
		std::function<const bool(CUIFinger&)> cb);

	void _RegistWinbioFP(
		CUIFinger* finger);

	void _DeleteAllWinbioFP();

	void _DeleteWinbioFP(
		CUIFinger* finger);

	void UpdateUI(CUIFinger* finger);
	HRESULT closeSession();
	HRESULT GetCurrentUserIdentity(
		__inout PWINBIO_IDENTITY Identity);

	void _ResetRegistUI();

	DUI_DECLARE_MESSAGE_MAP()
		virtual void OnWindowInit(
			TNotifyUI& msg);
		virtual void OnMouseEnter(
			TNotifyUI& msg);
		virtual void OnMouseLeave(
			TNotifyUI& msg);
		virtual void OnOptionChange(
			TNotifyUI& msg);
		virtual void OnButtonClick(
			TNotifyUI& msg);
};

