#include "stdafx.h"
#include "MarkDialog.h"

DUI_BEGIN_MESSAGE_MAP(CMarkDialog, WindowImplBase)
DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnWindowInit)
DUI_END_MESSAGE_MAP()

CMarkDialog* CMarkDialog::sm_mark;

void CMarkDialog::ShowMark(
	HWND parent,
	std::function<void()> cb)
{
	sm_mark = new CMarkDialog;
	sm_mark->Create(
		parent, 
		_T("Mark"), 
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_TOOLWINDOW, 
		0, 
		0, 
		0, 
		0);
	sm_mark->CenterWindow();
	sm_mark->ShowWindow();
	sm_mark->m_cb = cb;
}

void CMarkDialog::OnWindowInit(
	TNotifyUI& msg)
{
	if(m_cb)
		m_cb();
}

void CMarkDialog::DeleteMark()
{
	if (sm_mark) 
	{
		sm_mark->Close(0L);
		sm_mark = nullptr;
	}
}

HWND CMarkDialog::GetMarkHwnd() 
{
	return sm_mark ? sm_mark->m_hWnd : 0;
}

LRESULT CMarkDialog::HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) 
{
	if (uMsg == WM_DESTROY) 
	{
		bHandled = TRUE;
		return 0;
	}
	return 0;
}

LRESULT CMarkDialog::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) 
{
	// ʱյWM_NCDESTROYյwParamΪSC_CLOSEWM_SYSCOMMAND
	if (wParam == SC_CLOSE) {
		::PostQuitMessage(0L);
		bHandled = TRUE;
		return 0;
	}
	BOOL bZoomed = ::IsZoomed(*this);
	LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
	return lRes;
}