#include "stdafx.h"
#include "PopupDialog.h"

DUI_BEGIN_MESSAGE_MAP(CPopupDialog, WindowImplBase)
	DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, OnButtonClick)
DUI_END_MESSAGE_MAP()

CPopupDialog* CPopupDialog::sm_dialog = nullptr;

void CPopupDialog::Popup(
	HWND parent, 
	PopType type, 
	const std::wstring text,
	const bool bQuit)
{
	sm_dialog = new CPopupDialog(type, text, bQuit);
	CMarkDialog::ShowMark(parent, nullptr);
	sm_dialog->Create(CMarkDialog::GetMarkHwnd(), _T("Popup"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
		WS_EX_TOOLWINDOW,
		0,
		0,
		0,
		0);
	sm_dialog->CenterWindow();
	sm_dialog->ShowModal();
	CMarkDialog::DeleteMark();
	sm_dialog = nullptr;
}

void CPopupDialog::InitWindow()
{
	m_UIBtnClose = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Close"));
	m_UIBtnOK = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_ok"));
	m_UILabel = static_cast<CButtonUI*>(m_pm.FindControl(L"Label_Text"));
	m_UIIcon = static_cast<CTextUI*>(m_pm.FindControl(L"img_icon"));

	if (Warning == m_type)
		m_UIIcon->SetBkImage(L"Images\\img_warning.png");
	m_UILabel->SetText(m_text.c_str());
}

void CPopupDialog::OnButtonClick(TNotifyUI& msg)
{
	if (m_UIBtnClose == msg.pSender || m_UIBtnOK == msg.pSender) {
		if (m_bQuit) 
			PostQuitMessage(0L);
		Close(0L);
	}
}

LRESULT CPopupDialog::HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) 
{
	if (uMsg == WM_DESTROY) {
		bHandled = TRUE;
		return 0;
	}
	return 0;
}

LRESULT CPopupDialog::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// ʱյWM_NCDESTROYյwParamΪSC_CLOSEWM_SYSCOMMAND
	if (wParam == SC_CLOSE) {
		::PostQuitMessage(0L);
		bHandled = TRUE;
		return 0;
	}
	BOOL bZoomed = ::IsZoomed(*this);
	LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
	return lRes;
}