#pragma once
#include "MarkDialog.h"
class CPopupDialog :
	public WindowImplBase
{
public:
	enum PopType {
		Warning,
		Error,
	};
	static CPopupDialog* sm_dialog;
	CButtonUI* m_UIBtnClose, *m_UIBtnOK;
	CLabelUI* m_UILabel;
	CTextUI* m_UIIcon;
	PopType m_type;
	BOOL m_bQuit;
	std::wstring m_text;
public:
	CPopupDialog(PopType type, const std::wstring text,
		const bool bQuit):
		m_UIBtnClose(nullptr),
		m_UIBtnOK(nullptr),
		m_UILabel(nullptr),
		m_UIIcon(nullptr),
		m_bQuit(false){
		m_type = type;
		m_bQuit = bQuit;
		m_text = text;
	}
	virtual ~CPopupDialog() {}

	static VOID Popup(
		HWND parent, 
		PopType type, 
		const std::wstring text,
		const bool bQuit);

	virtual VOID InitWindow();

	LRESULT HandleCustomMessage(
		UINT uMsg, 
		WPARAM wParam, 
		LPARAM lParam, 
		BOOL& bHandled);

	LRESULT OnSysCommand(
		UINT uMsg, 
		WPARAM wParam, 
		LPARAM lParam, 
		BOOL& bHandled);

	virtual CDuiString GetSkinFile() {
		return _T("Error.xml");
	}

	virtual LPCTSTR GetWindowClassName() CONST {
		return _T("WhoAreYou_Popup");
	}

	virtual void OnFinalMessage(HWND hWnd) {
		__super::OnFinalMessage(hWnd);
		delete this;
	}

	virtual void Notify(TNotifyUI &msg) {
		return WindowImplBase::Notify(msg);
	}
	DUI_DECLARE_MESSAGE_MAP()
		virtual VOID OnButtonClick(TNotifyUI& msg);
};
