#include "stdafx.h"
#include "UIFinger.h"


//ʼָ
const bool CUIFinger::InitFingers(
	CPaintManagerUI* pm,
	std::vector<CUIFinger>& fingers)
{
	if (!pm)
		return false;
	decltype(WINBIO_ANSI_381_POS_UNKNOWN) type = WINBIO_ANSI_381_POS_RH_THUMB;

	auto func = [&](
		std::wstring flag,
		const int pos) {

		CUIFinger finger;
		TCHAR number[16] = { 0 };
		_itow(pos, number, 10);
		std::wstring temp = L"checkbox_"; temp += flag + L"_hand_" + number + L"_finger";
		std::wstring temp2 = L"img_"; temp2 += flag + L"_hand_fingerprint_" + number;
		std::wstring temp3 = L"img_"; temp3 += flag + L"_hand_scan_"; temp3 += number;
		finger.m_UIOption = static_cast<COptionUI*>(pm->FindControl(temp.c_str()));
		finger.m_UIFingerprint = static_cast<CTextUI*>(pm->FindControl(temp2.c_str()));
		finger.m_UIScanImg = static_cast<CTextUI*>(pm->FindControl(temp3.c_str()));
		finger.m_Type = type;
		finger.m_bAnimationFlag = false;
		finger.m_bRegisted = false;
		fingers.push_back(finger);
	};

	for (INT n = 1; n <= 5; n++, type++)
		func(L"right", n);

	type = WINBIO_ANSI_381_POS_LH_THUMB;
	for (INT n = 6; n <= 10; n++, type++)
		func(L"left", n);
	return true;
}

//ƶOptionʱɨ״̬
const bool CUIFinger::IsEnter(TNotifyUI& msg)
{
	if (msg.pSender != m_UIOption)
		return false;
	if (m_bRegisted)
		return true;

	m_UIScanImg->SetVisible(true);
	m_bAnimationFlag = false;
	//ʱʱ50ms
	m_timer.Start(50,
		[&](void* arg) {
		CUIFinger* finger = (CUIFinger*)arg;
		RECT padding = finger->m_UIScanImg->GetPadding();
		if (padding.top == -30)
			finger->m_bAnimationFlag = false;
		if (padding.top == 0)
			finger->m_bAnimationFlag = true;
		if (!finger->m_bAnimationFlag)
			padding.top += 2;
		else
			padding.top -= 2;
		finger->m_UIScanImg->SetPadding(padding);
	}, this);
	return true;
}

//뿪Optionʱظʼ״̬
const bool CUIFinger::IsLeave(TNotifyUI& msg)
{
	if (msg.pSender != m_UIOption)
		return false;
	RECT rect = { 0 };
	m_timer.Kill();
	m_UIScanImg->SetVisible(false);
	rect = m_UIScanImg->GetPadding();
	rect.top = -30;
	m_UIScanImg->SetPadding(rect);
	return true;
}

//ʼʾָע״̬
//עʱʾָע״̬
void CUIFinger::Regist(
	const bool bRegist)
{
	if (bRegist) {
		m_UIFingerprint->SetVisible(true);
		m_UIOption->Selected(false);
		m_UIOption->SetToolTip(L"Click to delete");
		m_bRegisted = true;
	}
	else {
		m_UIOption->Selected(false);
		m_UIFingerprint->SetVisible(false);
		m_bRegisted = false;
		m_UIOption->SetToolTip(L"Register your fingerprint");
	}
}