#include "stdafx.h"
#include "WindowsPwdDialog.h"
#include "MarkDialog.h"
#include "..\WAYBasics\Common.h"
//#include "..\WAYBasics\DBQuerys.h"

DUI_BEGIN_MESSAGE_MAP(CWindowsPwdDialog, WindowImplBase)
DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, OnButtonClick)
DUI_ON_MSGTYPE(DUI_MSGTYPE_SETFOCUS, OnFocus)
DUI_ON_MSGTYPE(DUI_MSGTYPE_KILLFOCUS, OnKillFocus)
DUI_END_MESSAGE_MAP()

CWindowsPwdDialog* CWindowsPwdDialog::sm_dialog = nullptr;

bool CWindowsPwdDialog::Popup(HWND parent)
{
	bool bCancel = false;
	sm_dialog = new CWindowsPwdDialog(&bCancel);
	CMarkDialog::ShowMark(parent,nullptr);
	sm_dialog->Create(CMarkDialog::GetMarkHwnd(), _T("Popup"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_TOOLWINDOW, 0, 0, 0, 0);
	sm_dialog->CenterWindow();
	sm_dialog->ShowModal();
	CMarkDialog::DeleteMark();
	sm_dialog = nullptr;
	return bCancel;
}

void CWindowsPwdDialog::InitWindow()
{
	_UIBtnClose = static_cast<CButtonUI*>(m_pm.FindControl(L"Btn_Close"));
	_UIBtnPwdOK = static_cast<CButtonUI*>(m_pm.FindControl(L"btn_winLogin_pwd_ok"));
	_UIBtnDlgSetting = static_cast<CButtonUI*>(m_pm.FindControl(L"btn_winLogin_dlg_setting"));
	_UIEditPassword = static_cast<CEditUI*>(m_pm.FindControl(L"edit_winLogin_pwd"));
	_UILabelTip = static_cast<CLabelUI*>(m_pm.FindControl(L"label_winLogin_dlg_text1"));
	_UIEditPasswordBG = static_cast<CTextUI*>(m_pm.FindControl(L"img_edit_winLogin_pwd"));

}

bool CWindowsPwdDialog::_HelpWindowsUrl()
{
	//ȡϵͳ汾
	std::string osName = WAY::Common::GetSystemName();
	if (osName == "Microsoft Windows 7")
	{
		std::string winName = "HelpWin7", url;
		url = "https://www.whoareyou.live/include/pc_client/winhello_win7.html";
		//DBQuerys::Instance()->QueryWindowsHelpConfig(winName, url);
		ShellExecuteA(NULL,
			"open",
			url.c_str(),
			nullptr,
			nullptr,
			SW_SHOW);
		return true;
	}
	else if (osName == "Microsoft Windows 8")
	{
		std::string winName = "HelpWin8", url;
		url = "https://www.whoareyou.live/include/pc_client/winhello_win8.html";
		//DBQuerys::Instance()->QueryWindowsHelpConfig(winName, url);
		ShellExecuteA(NULL,
			"open",
			url.c_str(),
			nullptr,
			nullptr,
			SW_SHOW);
		return true;
	}
	else if (osName == "Microsoft Windows 8.1")
	{
		std::string winName = "HelpWin8_1", url;
		url = "https://www.whoareyou.live/include/pc_client/winhello_win8.1.html";
		//DBQuerys::Instance()->QueryWindowsHelpConfig(winName, url);
		ShellExecuteA(NULL,
			"open",
			url.c_str(),
			nullptr,
			nullptr,
			SW_SHOW);
		return true;
	}
	else if (osName == "Microsoft Windows 10")
	{
		std::string winName = "HelpWin10", url;
		url = "https://www.whoareyou.live/include/pc_client/winhello_win10.html";
		//DBQuerys::Instance()->QueryWindowsHelpConfig(winName, url);
		ShellExecuteA(NULL,
			"open",
			url.c_str(),
			nullptr,
			nullptr,
			SW_SHOW);
		return true;
	}
	return false;
}

void CWindowsPwdDialog::OnButtonClick(TNotifyUI& msg)
{
	if (_UIBtnClose == msg.pSender)
	{
		*_bCancel = true;
		Close();
	}
	else if (_UIBtnDlgSetting == msg.pSender)
	{
		_HelpWindowsUrl();
	}
	else if (_UIBtnPwdOK == msg.pSender)
	{
		DWORD cb = 128;
		CHAR winUsername[128] = { 0 };

		if (!_UIEditPassword->GetText().GetLength())
		{
			_UIBtnDlgSetting->SetVisible(false);
			SET_ERROR_UI_TEXT(
				_UILabelTip,
				L"Please enter your Windows login password",
				239, 141, 6);
			return;
		}

		//ȡϵͳûusername
		::GetUserNameA(winUsername, &cb);
		std::string tempUserName = winUsername;
		wchar_t wWinUsername[128] = { 0 };
		WAY::Common::Char2Tchar(
			(char *)tempUserName.c_str(),
			tempUserName.length(),
			wWinUsername,
			128);

		//ȡûpassword
		wchar_t wWinPwd[128] = { 0 };
		_tcscpy(wWinPwd, (TCHAR*)_UIEditPassword->GetText().GetData());

		//һLsaLogonUser
		//LogonUser
		if (LogonUser(wWinUsername, _T("."), wWinPwd, LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, &hUser))
			//if (LogonUser(_T("Champion"), _T("."), _T("123"), LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, &hUser))
		{
			SET_ERROR_UI_TEXT(
				_UILabelTip,
				L"Login OK",
				239, 141, 6);
			*_bCancel = false;
			Close();
		}
		else
		{
			SET_ERROR_UI_TEXT(
				_UILabelTip,
				L"Wrong login password",
				239, 141, 6);
		}
	}
}

void CWindowsPwdDialog::OnFocus(TNotifyUI& msg)
{
	CTextUI* ptr = nullptr;
	if (_UIEditPassword == msg.pSender)
	{
		ptr = _UIEditPasswordBG;
		SET_ERROR_UI_TEXT(
			_UILabelTip,
			L"If you have not set the Windows login password,",
			114, 114, 127);
		_UIBtnDlgSetting->SetVisible(true);
	}

	if (ptr)
	{
		ptr->SetBkImage(L"Images\\input_enable.png");
	}
}


void CWindowsPwdDialog::OnKillFocus(TNotifyUI& msg)
{
	CTextUI* ptr = nullptr;
	if (_UIEditPassword == msg.pSender)
		ptr = _UIEditPasswordBG;
	if (ptr)
	{
		ptr->SetBkImage(L"Images\\input_normal.png");
	}
}

LRESULT CWindowsPwdDialog::HandleCustomMessage(
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam,
	BOOL& bHandled)
{
	if (uMsg == WM_DESTROY)
	{
		bHandled = true;
		return 0;
	}
	else if (uMsg == WM_TIMER)
	{
		OnTimer(uMsg, wParam, lParam, bHandled);
		bHandled = true;
		return 0;
	}
	return 0;
}

LRESULT CWindowsPwdDialog::OnSysCommand(
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam,
	BOOL& bHandled) {
	// ʱյWM_NCDESTROYյwParamΪSC_CLOSEWM_SYSCOMMAND
	if (wParam == SC_CLOSE)
	{
		::PostQuitMessage(0L);
		bHandled = true;
		return 0;
	}
	BOOL bZoomed = ::IsZoomed(*this);
	LRESULT lRes = CWindowWnd::HandleMessage(uMsg, wParam, lParam);
	return lRes;
}